{

 }
CON
_clkmode = xtal1 + pll16x                                               
_xinfreq = 5_000_000

'I2C pins
SDA_pin = 29
SCL_pin = 28
Bitrate = 100_000              

'Buffer address registers
Seconds = 0
Minutes = 1
Hours   = 2
Day     = 3
Date    = 4
Month   = 5
Year    = 6

'Useful assignments

Sunday    = $01
Monday    = $02
Tuesday   = $03
Wednesday = $04
Thursday  = $05
Friday    = $06
Saturday  = $07

January   = $01
February  = $02
March     = $03
April     = $04
May       = $05
June      = $06
July      = $07
August    = $08
September = $09
October   = $10
November  = $11
December  = $12

VAR
  byte  buffer[7]       
                                                                                                     
OBJ
  LCD : "LCD_8x2_4bit"
  I2C : "I2C driver"
  debug : "FullDuplexSerial"

PUB Main | t
  I2C.start(SCL_pin,SDA_pin,Bitrate)
  debug.start(31,30,0,57600)
  LCD.START
  LCD.CLEAR
  LCD.MOVE(1,1) 
  
  waitcnt(clkfreq + cnt)

  buffer[seconds] := $30                                                         
  buffer[minutes] := $59                                                      
  buffer[hours] := %0010_0011                                                 
  buffer[Day] := Thursday                                                     
  buffer[Date] := $31
  buffer[Month] := December
  buffer[Year] := $00

  I2C.write_page(I2C#RTC,Seconds,@buffer[seconds],7)

  repeat
    waitcnt(cnt + clkfreq)
    I2C.read_page(I2C#RTC,Seconds,@buffer,7)
      LCD.hex(buffer[date],2)                                           
      LCD.str(string("/"))
      LCD.hex(buffer[month],2)
      LCD.str(string("/"))
      LCD.hex(buffer[year],2)
      LCD.move(1,2)
      LCD.hex(buffer[hours],2)
      LCD.str(string(":"))
      LCD.hex(buffer[minutes],2)
      LCD.str(string(":"))
      LCD.hex(buffer[seconds],2)

    ' just want to make sure the clock section is working properly
      debug.tx($00)
      debug.hex(buffer[date],2)                                                   
      debug.tx("/")
      debug.hex(buffer[month],2)
      debug.tx("/")
      debug.hex(buffer[year],2)
      debug.tx(" ")
      debug.hex(buffer[hours],2)
      debug.tx(":")
      debug.hex(buffer[minutes],2)
      debug.tx(":")
      debug.hex(buffer[seconds],2)
      
